#!/usr/bin/perl -w
use strict;
#use diagnostics;

#(This license is from zlib of Jean-loup Gailly and Mark Adler)
#
# Copyright (C) 2002 Frederick Dean <software@fdd.com>
#
#  This software is provided 'as-is', without any express or implied
#  warranty.  In no event will the authors be held liable for any damages
#  arising from the use of this software.
#
#  Permission is granted to anyone to use this software for any purpose,
#  including commercial applications, and to alter it and redistribute it
#  freely, subject to the following restrictions:
#
#  1. The origin of this software must not be misrepresented; you must not
#     claim that you wrote the original software. If you use this software
#     in a product, an acknowledgment in the product documentation would be
#     appreciated but is not required.
#  2. Altered source versions must be plainly marked as such, and must not be
#     misrepresented as being the original software.
#  3. This notice may not be removed or altered from any source distribution.
#
# Contributor(s):    Frederick Dean <software@fdd.com>

require cgi;
require db;
require cvsdb;
require cvsweb;

package co_html;

sub checkout_html  {
   my($filename,$file_id,$inforef) = @_;

   common_html::content_type("text/html");
   my $rev; 
   if($cgi::form{'rev'}) {
      $rev = $cgi::form{'rev'};
   } elsif($cgi::form{'tag'}) {
      db::SendSQL("SELECT revision FROM label WHERE file_id = $file_id AND label = ".db::SqlQuote($cgi::form{'tag'}));
      $rev = db::FetchOneColumn();
   } elsif($cgi::form{'branch'}) {
      my @rows = cvsdb::GetFiles("revision.revision","dirent.file_id = $file_id","revision.revision",
                                 $cgi::form{'latest'},$cgi::form{'branch'},$cgi::label{'label'});
      $rev = ${$rows[0]}[0];
   } else {  # last resort
      $rev = $$inforef{'head'};
   };     
   my %revision;
   cvsdb::GetRevInfoFromDb(\%revision,$file_id,undef,"AND revision.revision = ".db::SqlQuote($rev));
   $cgi::keyword{'revInfo'} = common_html::HtmlRevInfo($filename,$file_id,\%revision);
   $cgi::keyword{'text'} = cgi::htmlQuoteForPre(scalar(cvsdb::GetText($file_id,$rev)));
   common_html::branchesWidget_keyword("dirent.file_id = $file_id"); 
   $cgi::keyword{'latest'} = cgi::htmlQuote($cgi::form{'latest'});
   print cgi::expand_template_keywords("template/co-template.html");
}


1;

