#!/usr/bin/perl -w
use strict;
#use diagnostics;

#(This license is from zlib of Jean-loup Gailly and Mark Adler)
#
# Copyright (C) 2002 Frederick Dean <software@fdd.com>
#
#  This software is provided 'as-is', without any express or implied
#  warranty.  In no event will the authors be held liable for any damages
#  arising from the use of this software.
#
#  Permission is granted to anyone to use this software for any purpose,
#  including commercial applications, and to alter it and redistribute it
#  freely, subject to the following restrictions:
#
#  1. The origin of this software must not be misrepresented; you must not
#     claim that you wrote the original software. If you use this software
#     in a product, an acknowledgment in the product documentation would be
#     appreciated but is not required.
#  2. Altered source versions must be plainly marked as such, and must not be
#     misrepresented as being the original software.
#  3. This notice may not be removed or altered from any source distribution.
#
# Contributor(s):    Frederick Dean <software@fdd.com>

require cgi;
require db;
require cvsdb;
require cvsweb;
require rcsdiff;
require unixdiff;
require cdiff;

package diff_html;

sub diff_html  {
   my($filename,$file_id,$inforef) = @_;

   my $rev2 = $cgi::form{'r2'};
   my $rev1 = $cgi::form{'r1'}; 
   my @text1 = cvsdb::GetText($file_id,$rev1);
   my @text2 = cvsdb::GetText($file_id,$rev2);
   my %revision1;
   cvsdb::GetRevInfoFromDb(\%revision1,$file_id,undef,"AND revision.revision = ".db::SqlQuote($rev1));
   $cgi::keyword{'revInfo1'} = common_html::HtmlRevInfo($filename,$file_id,\%revision1);
   my %revision2;
   cvsdb::GetRevInfoFromDb(\%revision2,$file_id,undef,"AND revision.revision = ".db::SqlQuote($rev2));
   $cgi::keyword{'revInfo2'} = common_html::HtmlRevInfo($filename,$file_id,\%revision2);

   #db::SendSQL("SELECT timestamp FROM revision WHERE file_id = $file_id AND revision = ".db::SqlQuote($rev1));
   #my($ts1) = db::FetchSQLData();
   #db::SendSQL("SELECT timestamp FROM revision WHERE file_id = $file_id AND revision = ".db::SqlQuote($rev2));
   #my($ts2) = db::FetchSQLData();
   $cgi::form{'diffmode'} ||= "";   # make defined
   if($cgi::form{'diffmode'} eq "raw-unidiff") {
      common_html::content_type("text/plain");
      print cdiff::cdiff(\@text2,\@text1,$filename,$filename,$revision2{$rev2}{'timestamp'},
                         $revision1{$rev1}{'timestamp'},"",$rev2,$rev1);
      exit;
   } elsif($cgi::form{'diffmode'} eq "unixdiff") {
      common_html::content_type("text/html");
      $cgi::keyword{'diff'} = cgi::htmlQuoteForPre(unixdiff::unixdiff(\@text2,\@text1,""));
   } elsif($cgi::form{'diffmode'} eq "2col-diff") {
      common_html::content_type("text/html");
      $cgi::keyword{'diff'} = "<font color=red>We were joking about that link.</font>\n";
   } else {
      common_html::content_type("text/html");
      $cgi::keyword{'diff'} = cgi::htmlQuoteForPre(cdiff::cdiff(\@text2,\@text1,$filename,$filename,
                                          $revision2{$rev2}{'timestamp'},$revision1{$rev1}{'timestamp'},"",$rev2,$rev1));
      $cgi::keyword{'diff'} =~ s/^(\+.*)\n/<font color=blue>$1<\/font>\n/gm;
      $cgi::keyword{'diff'} =~ s/^(\-.*)\n/<font color=red>$1<\/font>\n/gm;
   }
   $cgi::keyword{'diffmodeurl'} = $cgi::keyword{'selfurl'} . ".diff?r1=$rev1&r2=$rev2&diffmode=";

   #$cgi::keyword{'text'} = cgi::htmlQuoteForPre(scalar(cvsdb::GetText($file_id,$rev)));
   #common_html::branchesWidget_keyword("dirent.file_id = $file_id"); 
   #$cgi::keyword{'latest'} = cgi::htmlQuote($cgi::form{'latest'});

   $cgi::keyword{'diff'} = "<i><font color=red>no difference</font></i>" if $cgi::keyword{'diff'} !~ /\n/;

   print cgi::expand_template_keywords("template/diff-template.html");
}


1;

