#!/usr/bin/perl -w
use strict;
#use diagnostics;

#(This license is from zlib of Jean-loup Gailly and Mark Adler)
#
# Copyright (C) 2002 Frederick Dean <software@fdd.com>
#
#  This software is provided 'as-is', without any express or implied
#  warranty.  In no event will the authors be held liable for any damages
#  arising from the use of this software.
#
#  Permission is granted to anyone to use this software for any purpose,
#  including commercial applications, and to alter it and redistribute it
#  freely, subject to the following restrictions:
#
#  1. The origin of this software must not be misrepresented; you must not
#     claim that you wrote the original software. If you use this software
#     in a product, an acknowledgment in the product documentation would be
#     appreciated but is not required.
#  2. Altered source versions must be plainly marked as such, and must not be
#     misrepresented as being the original software.
#  3. This notice may not be removed or altered from any source distribution.
#
# Contributor(s):    Frederick Dean <software@fdd.com>

require useradmin;
require error_html;

package prefs_html;

sub prefs_html
{
   my($filename,$file_id,$inforef) = @_;

   session::require_login();
   common_html::content_type("text/html");
   if($cgi::form{'change_password'}) {
      my @userinfo = session::isPasswordValid($cgi::keyword{'username'},$cgi::form{'oldPasswd'});
      if(! defined $userinfo[0]) {
         error_html::fatal("Wrong old password.");
         exit;
      };
      if($userinfo[5] eq "os") {  # if pwtype is not type "go to operating system"
         error_html::fatal("Your password validates with the operating system.<br>" .
                    "I don't know how to change what the OS is looking for. Sorry.");
         exit;
      };
      if($cgi::form{'newPasswd'} ne $cgi::form{'newPasswd2'}) {
         error_html::fatal("Your new passwords do not match.");
         exit;
      }
      if(length $cgi::form{'newPasswd'} < $config::minPasswdLen) {
         error_html::fatal("Your new password is too short.  The minimum is $config::minPasswdLen characters.");
         exit;
      }
      useradmin::set_user($cgi::keyword{'username'},$cgi::form{'newPasswd'});
      $cgi::keyword{'warning'} = "Okay, we changed your password.<br>\n";
   };
   $cgi::keyword{"prevurl"} = $ENV{REQUEST_URI};
   print cgi::expand_template_keywords("template/prefs-template.html");
}

1;

