#!/usr/bin/perl -w -T
use strict;

#
#  This tiny fragment of a program is suppose to authenticate passwords.
#  It needs to be SUID root on most systems.
#  The username and password are give on the first two lines of input.
#

%ENV = ();  # happier taint

if(-t STDOUT)  {  # if STDOUT is still open
   print(STDOUT "This script is used by DCVS to verify operating system user accounts/passwords.\n".
                "You shouldn't run it like this.\n");
   exit -3;
}

my $user = <STDIN>;
chomp($user);
$user =~ /^(\w+)$/ or die "bad character in username";  # only alphanumerics for de-tainting
$user = $1;
my $pass = <STDIN>;
chomp($pass);

my($login,$pwd) = getpwnam($user);

if(! defined $login) {  # user doesn't exist
   sleep(1);
   exit 0;
} elsif(length($pwd) < 8) {
   print(STDERR "pwverify.pl: could not get crypt password.\n");
   exit 33;
} elsif(crypt($pass, $pwd) ne $pwd) {  # if bad password
   sleep(1);
   exit 0;
} else {
   exit 183;   # crazy value unlikely to be inadvertantly matched
}

