#!/usr/bin/perl -w 
use strict;
#use diagnostics;

#(This license is from zlib of Jean-loup Gailly and Mark Adler)
#
# Copyright (C) 2002 Frederick Dean <software@fdd.com>
#
#  This software is provided 'as-is', without any express or implied
#  warranty.  In no event will the authors be held liable for any damages
#  arising from the use of this software.
#
#  Permission is granted to anyone to use this software for any purpose,
#  including commercial applications, and to alter it and redistribute it
#  freely, subject to the following restrictions:
#
#  1. The origin of this software must not be misrepresented; you must not
#     claim that you wrote the original software. If you use this software
#     in a product, an acknowledgment in the product documentation would be
#     appreciated but is not required.
#  2. Altered source versions must be plainly marked as such, and must not be
#     misrepresented as being the original software.
#  3. This notice may not be removed or altered from any source distribution.
#
# Contributor(s):    Frederick Dean <software@fdd.com>

# Add the directory of the executable to the module search path.
BEGIN { push(@INC,"/var/www/html/dcvs"); }   # library include path

require config;
use db;
#use cvsdb;

if(! defined $ARGV[0] || $ARGV[0] ne "--dataloss") {
   print STDERR "\n".
                "      Your DCVS database will loose all revisions!\n".
                "      Only run this script if you want to loose data!\n".
                "      Use the --dataloss flag if you are sure.\n".
                "      The database was not altered.\n".
                "\n";
   exit -1;
}

db::SendSQL("DELETE FROM dirent");  # delete all directories and files
db::SendSQL("DELETE FROM descendent");  # delete all descendents
db::SendSQL("DELETE FROM revision");  # delete all revisions
db::SendSQL("DELETE FROM btime");  # delete all branches

db::SendSQL("REPLACE dirent SET file_id = 5000, fname = 'dir1', type = 'dir', parent = 0");
db::SendSQL("REPLACE dirent SET file_id = 5001, fname = 'dir2', type = 'dir', parent = 5000");
db::SendSQL("REPLACE dirent SET file_id = 5002, fname = 'dir3', type = 'dir', parent = 5003");  # directory loop
db::SendSQL("REPLACE dirent SET file_id = 5003, fname = 'dir4', type = 'dir', parent = 5002");
db::SendSQL("REPLACE dirent SET file_id = 5004, fname = 'dir5', type = 'dir', parent = 4999");  # dir with nonexistent parent
db::SendSQL("REPLACE dirent SET file_id = 6000, fname = 'file1', type = 'file', parent = 0");  # file in root (not error)
db::SendSQL("REPLACE dirent SET file_id = 6001, fname = '', type = 'file', parent = 5001");  # empty filename
db::SendSQL("REPLACE dirent SET file_id = 6002, fname = 'file2', type = 'file', parent = 6000");  # parent is file
db::SendSQL("REPLACE dirent SET file_id = 6003, fname = 'fi/le3', type = 'file', parent = 5000");  # illegal filename char
db::SendSQL("REPLACE dirent SET file_id = 6004, fname = '..', type = 'file', parent = 5000");  # illegal filename 
db::SendSQL("REPLACE dirent SET file_id = 6005, fname = '.', type = 'file', parent = 5000");  # illegal filename 
db::SendSQL("REPLACE dirent SET file_id = 6006, fname = 'file3', type = 'file', parent = 4999");  # non-existent parent 
db::SendSQL("REPLACE dirent SET file_id = 6007, fname = 'file4', type = 'file', parent = 5000");  
db::SendSQL("REPLACE dirent SET file_id = 6008, fname = 'file4', type = 'file', parent = 5000");  # duplicate filename same dir
db::SendSQL("REPLACE dirent SET file_id = 7000, fname = 'link1', type = 'link', parent = 0");  # non-file non-dir



