#!/usr/bin/perl -w
use strict;

BEGIN { push @INC, "/var/www/html/dcvs" };

use merge;

#
#  This is some white box texting.
#  We have a few canned sequences and their correct answers.
#  We compare it to the output of merge::merge();
#

my $oldtext = '0
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
';

my $newtext = '0
1
2
3
4
DDDDDD
EEEEEE
6
7
8
9
10
11
12
13
14
15
17
18
19
20
';

my $targettext = '0
1
2
3
4
5
6
7
8
9
10
11
FFFFFF
12
13
14
15
16
17
18
19
20
';

my($answer1,$conflict1) = merge::merge($oldtext,$targettext,$newtext,"new");
die if $conflict1;
die unless $answer1 eq
'0
1
2
3
4
DDDDDD
EEEEEE
6
7
8
9
10
11
FFFFFF
12
13
14
15
17
18
19
20
';

my $newtext2 = '0
1
2
3
4
DDDDDD
EEEEEE
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
GGGGGG
';

my($answer2,$conflict2) = merge::merge($oldtext,$targettext,$newtext2,"new2");
die if $conflict2;
die("{{{$answer2}}}\n ") unless $answer2 eq
'0
1
2
3
4
DDDDDD
EEEEEE
6
7
8
9
10
11
FFFFFF
12
13
14
15
16
17
18
19
20
GGGGGG
';

my $newtext3 = 'XXXXX
YYYYY
0
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
18
20
';

my($answer3,$conflict3) = merge::merge($oldtext,$targettext,$newtext3,"new3");
die if $conflict3;
die unless $answer3 eq
'XXXXX
YYYYY
0
1
2
3
4
5
6
7
8
9
10
11
FFFFFF
12
13
14
15
16
18
20
';

my $newtext4 = '0
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
';

my($answer4,$conflict4) = merge::merge($oldtext,$targettext,$newtext4,"new4");
die if $conflict4;
die unless $answer4 eq
'0
1
2
3
4
5
6
7
8
9
10
11
FFFFFF
12
13
14
15
16
17
18
19
20
';

my $newtext5 = '0
1
2
3
4
6
7
8
9
10
11
12
13
14
15
xxxxx
yyyy
17
16
ddddd
ddddd
18
19
20
';

my $targettext5 = '0
10
11
12
13
14
15
16
17
18
19
20
1
2
3
4
5
6
7
8
9
';

my($answer5,$conflict5) = merge::merge($oldtext,$targettext5,$newtext5,"new5");
die if $conflict5;
die unless $answer5 eq
'0
10
11
12
13
14
15
xxxxx
yyyy
17
16
ddddd
ddddd
18
19
20
1
2
3
4
6
7
8
9
';


my $oldtext6 = '0
1
';

my $newtext6 = '0
2
';

my $targettext6 = '0
1
';

my($answer6,$conflict6) = merge::merge($oldtext6,$targettext6,$newtext6,"new6");
die if $conflict6;
die unless $answer6 eq
'0
2
';

my $newtext6a = '0
1
';

my $targettext6a = '0
2
';

my($answer6a,$conflict6a) = merge::merge($oldtext6,$targettext6a,$newtext6a,"new6a");
die if $conflict6a;
die unless $answer6a eq
'0
2
';

my $oldtext7 = '0
1
2
3
4
6
7
8
9
';

my $newtext7 = '0
1
2
3
4
6
7
8
9
';

my $targettext7 = '0
1
2
3
4
5
6
7
8
9
';

my($answer7,$conflict7) = merge::merge($oldtext7,$targettext7,$newtext7,"new7");
die if $conflict7;
die unless $answer7 eq
'0
1
2
3
4
5
6
7
8
9
';


my $oldtext8 = '0
1
2
3
4
6
7
8
9
';

my $newtext8 = '0
1
2
3
4new
6
7
8
9
';

my $targettext8 = '0
1
2
3
4target
5
6
7
8
9
';

my($answer8,$conflict8) = merge::merge($oldtext8,$targettext8,$newtext8,"new8");

die("answer8\n{{{$answer8}}}\n ") unless $answer8 eq
'0
1
2
3
4target
5
6
7
8
9
';

die("conflict8\n{{{$conflict8}}}\n ") unless $conflict8 eq
'@@ -2,7 +2,7 @@
 1
 2
 3
-4
+4new
 6
 7
 8
';


my $oldtext9 = '0
1
2
3
4
6
7
8
9
';

my $newtext9 = '0
1
2new
3
4
6
7
8
9
';

my $targettext9 = '0
1
2
3
4target
5
6
7
8
9
1
2
3
4
5
6
';

my($answer9,$conflict9) = merge::merge($oldtext9,$targettext9,$newtext9,"new9");

die("answer9\n{{{$answer9}}}\n ") unless $answer9 eq
'0
1
2
3
4target
5
6
7
8
9
1
2
3
4
5
6
';

die("conflict9\n{{{$conflict9}}}\n ") unless $conflict9 eq
'@@ -1,6 +1,6 @@
 0
 1
-2
+2new
 3
 4
 6
';
































