#!/usr/bin/perl -w
use strict;
#use diagnostics;

#(This license is from zlib of Jean-loup Gailly and Mark Adler)
#
# Copyright (C) 2002 Frederick Dean <software@fdd.com>
#
#  This software is provided 'as-is', without any express or implied
#  warranty.  In no event will the authors be held liable for any damages
#  arising from the use of this software.
#
#  Permission is granted to anyone to use this software for any purpose,
#  including commercial applications, and to alter it and redistribute it
#  freely, subject to the following restrictions:
#
#  1. The origin of this software must not be misrepresented; you must not
#     claim that you wrote the original software. If you use this software
#     in a product, an acknowledgment in the product documentation would be
#     appreciated but is not required.
#  2. Altered source versions must be plainly marked as such, and must not be
#     misrepresented as being the original software.
#  3. This notice may not be removed or altered from any source distribution.
#
# Contributor(s):    Frederick Dean <software@fdd.com>

require users_html;
require useradmin;

package user_html;

sub problem
{
   my($filename,$file_id,$inforef,$warning) = @_;

   $cgi::keyword{'warning'} = $warning;
   users_html::users_html($filename,$file_id,$inforef);
}

sub user_html
{
   my($filename,$file_id,$inforef) = @_;

   common_html::content_type("text/html");
   session::require_group(1) or return;  # administrator group
   my $user =  $cgi::form{'user_new'};
   my($user_email,$user_realname,$user_disabledtext,$groups,$pwtype) = ("","","");
   $cgi::keyword{'updatecreate'} = " Create ";
   if(!$user) { 
      $user = $cgi::form{'user'};
      if(!defined($user)) {
         return problem($filename,$file_id,$inforef,"");
      };
      db::SendSQL("SELECT email, realname, disabledtext, groups, cryptpassword FROM user WHERE username = ".db::SqlQuote($user));
      ($user_email,$user_realname,$user_disabledtext,$groups,$pwtype) = db::FetchSQLData();
      $cgi::keyword{'updatecreate'} = " Update ";
      $pwtype = substr($pwtype,0,3);  
   }
   $cgi::keyword{'user_username'} = "$user<input type=hidden name=user_username value=".cgi::htmlQuote($user).">";
   $cgi::keyword{'user_email'} = $user_email;
   $cgi::keyword{'user_realname'} = $user_realname;
   $cgi::keyword{'user_disabledtext'} = $user_disabledtext || "";
   $cgi::keyword{'user_groups'} = join("  ",@{useradmin::groupList($groups)});
   $cgi::keyword{'user_pwtype_dcvs'} = ($pwtype eq "os") ? "" : "CHECKED";
   $cgi::keyword{'user_pwtype_os'} = ($pwtype eq "os") ? "CHECKED" : "";
   if(!defined($cgi::keyword{'user_email'})) {
      return problem($filename,$file_id,$inforef,"<font color=red>User \"".cgi::htmlQuote($user)."\" not found</font>\n");
   };
   $cgi::keyword{'formurl'} = cgi::Uri("$filename---users.html");
   print cgi::expand_template_keywords("template/user-template.html");
}

1;

