#!/usr/bin/perl -w
use strict;
#use diagnostics;

#(This license is from zlib of Jean-loup Gailly and Mark Adler)
#
# Copyright (C) 2002 Frederick Dean <software@fdd.com>
#
#  This software is provided 'as-is', without any express or implied
#  warranty.  In no event will the authors be held liable for any damages
#  arising from the use of this software.
#
#  Permission is granted to anyone to use this software for any purpose,
#  including commercial applications, and to alter it and redistribute it
#  freely, subject to the following restrictions:
#
#  1. The origin of this software must not be misrepresented; you must not
#     claim that you wrote the original software. If you use this software
#     in a product, an acknowledgment in the product documentation would be
#     appreciated but is not required.
#  2. Altered source versions must be plainly marked as such, and must not be
#     misrepresented as being the original software.
#  3. This notice may not be removed or altered from any source distribution.
#
# Contributor(s):    Frederick Dean <software@fdd.com>

require useradmin;

package users_html;

sub users_html
{
   my($filename,$file_id,$inforef) = @_;

   common_html::content_type("text/html");
   session::require_group(1) or return;  # administrator group
   if(!$session::group{1}) {
       error_html::fatal("Sorry, you do not have privileges to see this page, because ".
          "you do not belong to the administrator group.");
       return;
   }
   if($cgi::form{'user_username'}) {
      useradmin::set_user($cgi::form{'user_username'},$cgi::form{'user_password'},$cgi::form{'user_realname'},
                          $cgi::form{'user_email'},$cgi::form{'user_disabledtext'},undef,$cgi::form{'user_pwtype'});
      if(my $error = useradmin::set_groups($cgi::form{'user_username'},$cgi::form{'user_groups'})) {
         error_html::fatal($error);
         return;
      };
      $cgi::keyword{'warning'} .= "User \"".cgi::htmlQuote($cgi::form{'user_username'})."\" updated successfully.<br>";
   }
   db::SendSQL("SELECT username, email, realname FROM user ORDER BY username");
   my $numUsers = 0;
   my $usersTable = "<table>\n";
   $usersTable .= "<tr bgcolor=222277><th><font color=white>username</font></th>".
                                    " <th><font color=white>email</font></th>".
                                    " <th><font color=white>realname</font></th></tr>\n";
   while(my($username,$email,$realname,$disabledtext) = db::FetchSQLData()) {
      $numUsers++;
      $usersTable .= " <tr>\n";
      $usersTable .= "  <td>".cgi::Link("$filename---user.html","user=$username") . cgi::htmlQuote($username)."</td>\n";
      $usersTable .= "  <td>".cgi::htmlQuote($email)."</td>\n";
      $usersTable .= "  <td>".cgi::htmlQuote($realname)."</td>\n";
      $usersTable .= " </tr>\n";

   };
   $usersTable .= "</table>\n";
   if($numUsers) {
      $cgi::keyword{'usersTable'} = $usersTable;
   } else {
      $cgi::keyword{'usersTable'} = "<font color=red>No users found.</font><br>\n";
   };
   $cgi::keyword{'userSearch'} = $cgi::form{'userSearch'} || "r";
   $cgi::keyword{'numUsers'} = $numUsers;
   $cgi::keyword{'newuserurl'} = cgi::Uri("$filename---user.html");
   print cgi::expand_template_keywords("template/users-template.html");
}

1;

